/*	
 *	clipmisc.h
 *
 *	G[Ȃ낢łB
 *
 *	CLiP - Common Library for P/ECE
 *	Copyright (C) 2001 Naoyuki Sawa
 *
 *	* Wed Dec 12 21:51:29 JST 2001 Naoyuki Sawa
 *	- 쐬JnB
 */
#ifndef __CLIP_MISC_H__
#define __CLIP_MISC_H__

/*****************************************************************************
 *	ėp}N
 *****************************************************************************/

#define DIE()		die(__FILE__ "(%d)", __LINE__)
#ifdef DEBUG
#define ASSERT(f)	((void)((f) || (die(__FILE__ "(%d): %s", __LINE__, #f), 0)))
#define VERIFY(f)	ASSERT(f)
#else /*DEBUG*/
#define ASSERT(f)	((void)0)
#define VERIFY(f)	((void)(f))
#endif /*DEBUG*/

/* rbg */
#define BTST(a, b)	(((char*)(a))[(b) / 8] &    1 << ((b) & 7) )
#define BCLR(a, b)	(((char*)(a))[(b) / 8] &= ~(1 << ((b) & 7)))
#define BSET(a, b)	(((char*)(a))[(b) / 8] |=   1 << ((b) & 7) )
#define BNOT(a, b)	(((char*)(a))[(b) / 8] ^=   1 << ((b) & 7) )

/* 8rbg */
#define RAND(s)		(((s) = (s) * 5 + 0x3711) >> 8 & 0xFF)

/*****************************************************************************
 *	G[
 *****************************************************************************/

/* G[bZ[W\AvOI܂B
 * [in]
 *	fmt,...		printf()̈ƓlłB
 * [note]
 *	* ̊֐͏Ԃ܂B
 */
void die(const char* fmt, ...);

/*****************************************************************************
 *	t@CpbN`
 *****************************************************************************/

/*                           0 +-----------------------------+
 *                             | FILE_PAC_INFO               |
 *                             +-----------------------------+
 *                             | FILE_INFO[0]                |
 *                             +-----------------------------+
 *                             | FILE_INFO[1]                |
 *                             +-----------------------------+
 *                             =                             =
 *                             +-----------------------------+
 *                             | FILE_INFO[famount-1]        |
 *         FILE_INFO[0].offset +-----------------------------+|
 *                             |                             |
 *                             | t@C[0]̃f[^         |bFILE_INFO[0].size + 3 & ~3
 *                             |                             |
 *         FILE_INFO[1].offset +-----------------------------+|
 *                             |                             |
 *                             | t@C[1]̃f[^         |bFILE_INFO[1].size + 3 & ~3
 *                             |                             |
 *                             +-----------------------------+|
 *                             =                             =
 * FILE_INFO[famount-1].offset +-----------------------------+|
 *                             |                             |
 *                             | t@C[famount-1]̃f[^ |bFILE_INFO[famount-1].size
 *                             |                             |
 *                             +-----------------------------+|
 */
#define FILE_PAC_INFO_HEAD	 ('F' << 24 | 'P' << 16 | 'A' << 8 | 'K')
typedef struct _FILE_PAC_INFO {	/* t@CpbN                   */
	unsigned long head;	/* VOl`('FPAK'ŒBт"KAPF") */
	long famount;		/* t@C                           */
} FILE_PAC_INFO;
typedef struct _FILE_INFO {	/* t@C                         */
	char fname[16];		/* t@C                           */
	unsigned long offset;	/* ItZbg(fpkt@C擪0Ƃ) */
	unsigned long size;	/* t@CTCY                       */
} FILE_INFO;

#endif /*__CLIP_MISC_H__*/
