/*
 *	main.c
 *
 *	frlvC[
 *	Copyright (C) 2002 Naoyuki Sawa
 *
 *	* Mon Jun 21 21:26:00 JST 2002 Naoyuki Sawa
 *	- 쐬JnB
 */
#include <clip.h>

unsigned char vbuff[DISP_X * DISP_Y];	/* z */

#define CH		0		/* Đp`l */
#define LOOP		1		/* [v     */

#define MAX_FILES	6		/* őGSMt@C */
char files[MAX_FILES][MAXFILENAME + 1];	/* GSMt@CXg */
int n_files;				/* GSMt@C     */

int cursel;		/* ڂGSMt@CI𒆂H */
int prevsel;		/* ȎIځiĕ`挟opj    */

int
main()
{
	int pad, len, i, x, y;
	char* str;
	FILEINFO fi;

	/* ʓIȏB */
	pceLCDDispStop();
	pceLCDSetBuffer(vbuff);
	pceAppSetProcPeriod(100);
	pceLCDDispStart();

	/* tHgݒB */
	pceFontSetType(0x80);
	pceFontSetTxColor(3);
	pceFontSetBkColor(-1);

	/* IɊmɍĐ~悤ɁB */
	atexit(stream_stop);

	/* GSMt@CXg擾܂B */
	pceFileFindOpen(&fi);
	while(n_files < MAX_FILES && pceFileFindNext(&fi)) {
		len = strlen(fi.filename);
		if(len < 4) continue;
		if(strcmp(&fi.filename[len - 4], ".gsm") != 0) continue;
		strcpy(files[n_files++], fi.filename);
	}
	pceFileFindClose(&fi);
	if(n_files == 0) {
		memset(vbuff, 0, sizeof vbuff);
		str = "GSMt@C܂";
		len = strlen(str);
		x = (DISP_X - 5 * len) / 2;
		y = (DISP_Y - 10)      / 2;
		pceFontSetPos(x, y);
		pceFontPutStr(str);
		pceLCDTrans();
		for(;;) {
			yield();
			pad = pcePadGet();
			if(pad & TRG_MASK) exit(-1);
		}
	}

	/* C[vB */
	cursel = 0;	/* ڂ̃t@CI */
	prevsel = -1;	/* 񋭐ĕ`̂   */
	for(;;) {
		yield();

		/* L[B */
		pad = pcePadGet();
		if(pad & TRG_SELECT) break;
		if(pad & TRG_UP && cursel > 0          ) cursel--;
		if(pad & TRG_DN && cursel < n_files - 1) cursel++;
		if(pad & TRG_A) stream_play(CH, files[cursel], LOOP);
		if(pad & TRG_B) stream_stop();

		/* IڂςĂAĕ`悵܂B */
		if(cursel != prevsel) {
			memset(vbuff, 0, sizeof vbuff);
			/* ^Cg\B */
			y = 0;
			pceFontSetTxColor(0);
			pceFontSetBkColor(3);
			str = "=====frlvC[=====";
			len = strlen(str);
			x = (DISP_X - 5 * len) / 2;
			pceFontSetPos(x, y);
			pceFontPutStr(str);
			y += 12;
			/* t@CXg\B */
			for(i = 0; i < n_files; i++) {
				if(i == cursel) {
					pceFontSetTxColor(3);
					y += 2;
				} else {
					pceFontSetTxColor(1);
				}
				pceFontSetBkColor(0);
				str = files[i];
				len = strlen(str);
				x = (DISP_X - 5 * len) / 2;
				pceFontSetPos(x, y);
				pceFontPutStr(str);
				if(i == cursel) {
					y += 2;
				}
				y += 10;
			}
			/* \B */
			y = DISP_Y - 10;
			pceFontSetTxColor(0);
			pceFontSetBkColor(2);
			str = " A:Đ B:~ SELECT:I ";
			len = strlen(str);
			x = (DISP_X - 5 * len) / 2;
			pceFontSetPos(x, y);
			pceFontPutStr(str);

			pceLCDTrans();
			prevsel = cursel;
		}
	}

	return 0;
}
